package com.sun.corba.se.impl.encoding;

import java.nio.ByteBuffer;
import com.sun.corba.se.pept.protocol.MessageMediator;
import org.omg.CORBA.portable.BoxedValueHelper;
import java.io.Serializable;
import org.omg.CORBA.ContextList;
import org.omg.CORBA.Context;
import java.math.BigDecimal;
import java.io.IOException;
import org.omg.CORBA.Principal;
import org.omg.CORBA.Any;
import org.omg.CORBA.TypeCode;
import org.omg.CORBA.Object;
import org.omg.CORBA.portable.InputStream;
import com.sun.corba.se.spi.ior.iiop.GIOPVersion;
import com.sun.corba.se.spi.protocol.CorbaMessageMediator;
import com.sun.corba.se.impl.logging.ORBUtilSystemException;
import com.sun.corba.se.spi.orb.ORB;
import org.omg.CORBA.portable.ValueOutputStream;
import org.omg.CORBA.DataOutputStream;
import org.omg.CORBA_2_3.portable.OutputStream;

public abstract class CDROutputStream extends OutputStream implements MarshalOutputStream, DataOutputStream, ValueOutputStream
{
    private CDROutputStreamBase impl;
    protected ORB orb;
    protected ORBUtilSystemException wrapper;
    protected CorbaMessageMediator corbaMessageMediator;
    
    public CDROutputStream(ORB orb, GIOPVersion giopVersion, byte b, boolean b2, BufferManagerWrite bufferManagerWrite, byte b3, boolean b4) {
        (this.impl = CDROutputStream.OutputStreamFactory.newOutputStream(orb, giopVersion, b)).init(orb, b2, bufferManagerWrite, b3, b4);
        this.impl.setParent(this);
        this.orb = orb;
        this.wrapper = ORBUtilSystemException.get(orb, "rpc.encoding");
    }
    
    public CDROutputStream(ORB orb, GIOPVersion giopVersion, byte b, boolean b2, BufferManagerWrite bufferManagerWrite, byte b3) {
        this(orb, giopVersion, b, b2, bufferManagerWrite, b3, true);
    }
    
    public abstract InputStream create_input_stream();
    
    public final void write_boolean(boolean b) {
        this.impl.write_boolean(b);
    }
    
    public final void write_char(char c) {
        this.impl.write_char(c);
    }
    
    public final void write_wchar(char c) {
        this.impl.write_wchar(c);
    }
    
    public final void write_octet(byte b) {
        this.impl.write_octet(b);
    }
    
    public final void write_short(short n) {
        this.impl.write_short(n);
    }
    
    public final void write_ushort(short n) {
        this.impl.write_ushort(n);
    }
    
    public final void write_long(int n) {
        this.impl.write_long(n);
    }
    
    public final void write_ulong(int n) {
        this.impl.write_ulong(n);
    }
    
    public final void write_longlong(long n) {
        this.impl.write_longlong(n);
    }
    
    public final void write_ulonglong(long n) {
        this.impl.write_ulonglong(n);
    }
    
    public final void write_float(float n) {
        this.impl.write_float(n);
    }
    
    public final void write_double(double n) {
        this.impl.write_double(n);
    }
    
    public final void write_string(String s) {
        this.impl.write_string(s);
    }
    
    public final void write_wstring(String s) {
        this.impl.write_wstring(s);
    }
    
    public final void write_boolean_array(boolean[] array, int n, int n2) {
        this.impl.write_boolean_array(array, n, n2);
    }
    
    public final void write_char_array(char[] array, int n, int n2) {
        this.impl.write_char_array(array, n, n2);
    }
    
    public final void write_wchar_array(char[] array, int n, int n2) {
        this.impl.write_wchar_array(array, n, n2);
    }
    
    public final void write_octet_array(byte[] array, int n, int n2) {
        this.impl.write_octet_array(array, n, n2);
    }
    
    public final void write_short_array(short[] array, int n, int n2) {
        this.impl.write_short_array(array, n, n2);
    }
    
    public final void write_ushort_array(short[] array, int n, int n2) {
        this.impl.write_ushort_array(array, n, n2);
    }
    
    public final void write_long_array(int[] array, int n, int n2) {
        this.impl.write_long_array(array, n, n2);
    }
    
    public final void write_ulong_array(int[] array, int n, int n2) {
        this.impl.write_ulong_array(array, n, n2);
    }
    
    public final void write_longlong_array(long[] array, int n, int n2) {
        this.impl.write_longlong_array(array, n, n2);
    }
    
    public final void write_ulonglong_array(long[] array, int n, int n2) {
        this.impl.write_ulonglong_array(array, n, n2);
    }
    
    public final void write_float_array(float[] array, int n, int n2) {
        this.impl.write_float_array(array, n, n2);
    }
    
    public final void write_double_array(double[] array, int n, int n2) {
        this.impl.write_double_array(array, n, n2);
    }
    
    public final void write_Object(org.omg.CORBA.Object object) {
        this.impl.write_Object(object);
    }
    
    public final void write_TypeCode(TypeCode typeCode) {
        this.impl.write_TypeCode(typeCode);
    }
    
    public final void write_any(Any any) {
        this.impl.write_any(any);
    }
    
    public final void write_Principal(Principal principal) {
        this.impl.write_Principal(principal);
    }
    
    public final void write(int n) throws IOException {
        this.impl.write(n);
    }
    
    public final void write_fixed(BigDecimal bigDecimal) {
        this.impl.write_fixed(bigDecimal);
    }
    
    public final void write_Context(Context context, ContextList list) {
        this.impl.write_Context(context, list);
    }
    
    public final org.omg.CORBA.ORB orb() {
        return this.impl.orb();
    }
    
    public final void write_value(Serializable s) {
        this.impl.write_value(s);
    }
    
    public final void write_value(Serializable s, Class clazz) {
        this.impl.write_value(s, clazz);
    }
    
    public final void write_value(Serializable s, String s2) {
        this.impl.write_value(s, s2);
    }
    
    public final void write_value(Serializable s, BoxedValueHelper boxedValueHelper) {
        this.impl.write_value(s, boxedValueHelper);
    }
    
    public final void write_abstract_interface(Object o) {
        this.impl.write_abstract_interface(o);
    }
    
    public final void write(byte[] b) throws IOException {
        this.impl.write(b);
    }
    
    public final void write(byte[] b, int off, int len) throws IOException {
        this.impl.write(b, off, len);
    }
    
    public final void flush() throws IOException {
        this.impl.flush();
    }
    
    public final void close() throws IOException {
        this.impl.close();
    }
    
    public final void start_block() {
        this.impl.start_block();
    }
    
    public final void end_block() {
        this.impl.end_block();
    }
    
    public final void putEndian() {
        this.impl.putEndian();
    }
    
    public void writeTo(java.io.OutputStream outputStream) throws IOException {
        this.impl.writeTo(outputStream);
    }
    
    public final byte[] toByteArray() {
        return this.impl.toByteArray();
    }
    
    public final void write_Abstract(Object o) {
        this.impl.write_Abstract(o);
    }
    
    public final void write_Value(Serializable s) {
        this.impl.write_Value(s);
    }
    
    public final void write_any_array(Any[] array, int n, int n2) {
        this.impl.write_any_array(array, n, n2);
    }
    
    public void setMessageMediator(MessageMediator messageMediator) {
        this.corbaMessageMediator = (CorbaMessageMediator)messageMediator;
    }
    
    public MessageMediator getMessageMediator() {
        return this.corbaMessageMediator;
    }
    
    public final String[] _truncatable_ids() {
        return this.impl._truncatable_ids();
    }
    
    protected final int getSize() {
        return this.impl.getSize();
    }
    
    protected final int getIndex() {
        return this.impl.getIndex();
    }
    
    protected int getRealIndex(int n) {
        return n;
    }
    
    protected final void setIndex(int index) {
        this.impl.setIndex(index);
    }
    
    protected final ByteBuffer getByteBuffer() {
        return this.impl.getByteBuffer();
    }
    
    protected final void setByteBuffer(ByteBuffer byteBuffer) {
        this.impl.setByteBuffer(byteBuffer);
    }
    
    protected final boolean isSharing(ByteBuffer byteBuffer) {
        return this.getByteBuffer() == byteBuffer;
    }
    
    public final boolean isLittleEndian() {
        return this.impl.isLittleEndian();
    }
    
    public ByteBufferWithInfo getByteBufferWithInfo() {
        return this.impl.getByteBufferWithInfo();
    }
    
    protected void setByteBufferWithInfo(ByteBufferWithInfo byteBufferWithInfo) {
        this.impl.setByteBufferWithInfo(byteBufferWithInfo);
    }
    
    public final BufferManagerWrite getBufferManager() {
        return this.impl.getBufferManager();
    }
    
    public final void write_fixed(BigDecimal bigDecimal, short n, short n2) {
        this.impl.write_fixed(bigDecimal, n, n2);
    }
    
    public final void writeOctetSequenceTo(org.omg.CORBA.portable.OutputStream outputStream) {
        this.impl.writeOctetSequenceTo(outputStream);
    }
    
    public final GIOPVersion getGIOPVersion() {
        return this.impl.getGIOPVersion();
    }
    
    public final void writeIndirection(int n, int n2) {
        this.impl.writeIndirection(n, n2);
    }
    
    protected CodeSetConversion.CTBConverter createCharCTBConverter() {
        return CodeSetConversion.impl().getCTBConverter(OSFCodeSetRegistry.ISO_8859_1);
    }
    
    protected abstract CodeSetConversion.CTBConverter createWCharCTBConverter();
    
    protected final void freeInternalCaches() {
        this.impl.freeInternalCaches();
    }
    
    void printBuffer() {
        this.impl.printBuffer();
    }
    
    public void alignOnBoundary(int n) {
        this.impl.alignOnBoundary(n);
    }
    
    public void setHeaderPadding(boolean headerPadding) {
        this.impl.setHeaderPadding(headerPadding);
    }
    
    public void start_value(String s) {
        this.impl.start_value(s);
    }
    
    public void end_value() {
        this.impl.end_value();
    }
    
    private static class OutputStreamFactory
    {
        public static CDROutputStreamBase newOutputStream(ORB orb, GIOPVersion giopVersion, byte b) {
            switch (giopVersion.intValue()) {
                case 256: {
                    return new CDROutputStream_1_0();
                }
                case 257: {
                    return new CDROutputStream_1_1();
                }
                case 258: {
                    if (b != 0) {
                        return new IDLJavaSerializationOutputStream(b);
                    }
                    return new CDROutputStream_1_2();
                }
                default: {
                    throw ORBUtilSystemException.get(orb, "rpc.encoding").unsupportedGiopVersion(giopVersion);
                }
            }
        }
    }
}
